//---------------------------------------------------------------
// Function prototypes 
//---------------------------------------------------------------
void init_TPL0401_Booster(void);

void decode_Button(void);

unsigned short USCIAB0TX_ISR(void);
void USCIAB0RX_ISR(void);

void Timer_TX_ISR(void);
void send_TCA5405_byte(unsigned char byte);
void TCA5405_timer_ISR(void);
void TCA5405_TX_Byte(void);

unsigned char byte_flip_and_flag(unsigned char byte);

//-----------------------------------------------------------------
//	LED Driver I2C Definitions 
//-----------------------------------------------------------------
#define TLC59108_ADDRESS					0x40					//TLC59108 addres 100 0000 + (R/W bit)

//Individual PWM registers for each output
#define TLC59108_PWM0						0x02					//Duty cycle = data/256
#define TLC59108_PWM1						0x03
#define TLC59108_PWM2						0x04
#define TLC59108_PWM3						0x05
#define TLC59108_PWM4						0x06
#define TLC59108_PWM5						0x07
#define TLC59108_PWM6						0x08
#define TLC59108_PWM7						0x09

//TLC59108 requires two bits to control one output
//thus there are two output registers on the TLC59108				//	out 3 bits    out 2 bits     out 1 bits    out 0 bits
#define TLC59108_LED_OUT0					0x0C					// LDR3.1 LDR3.0 LDR2.1 LDR2.0 LDR1.1 LDR1.0 LDR0.1 LDR0.0

																	//	out 7 bits    out 6 bits     out 5 bits    out 4 bits
#define TLC59108_LED_OUT1					0x0D					// LDR7.1 LDR7.0 LDR6.1 LDR6.0 LDR5.1 LDR5.0 LDR4.1 LDR4.0

//Two bit definitions to be used with TLC59108 output registers
#define LED_OFF								0x00					//LED off
#define LED_ON								0x01					//LED on, ignores PWM and group dimming/blinking
#define LEDPWM_ON							0x02					//LED on with PWM but ignores group dimming/blinking
#define LEDGROUPPWM_ON						0x03					//LED on with PWM and group dimming/blinking

//-----------------------------------------------------------------
//	Color definitions based on TLC59108 output registers and
//	LEDPWM_ON. LSByte is TLC59108_LED_OUT0 MSbyte is OUT1.
//-----------------------------------------------------------------
#define BLUE 								0x8002					//   out 7   out 6  out 5  out 4  out 3  out 2  out 1   out 0 
																	// LEDPWM_ON  0 0    0 0    0 0    0 0	  0 0    0 0  LEDPWM_ON
																	
#define GREEN 								0x2008					//   out 7   out 6   out 5  out 4  out 3  out 2   out 1   out 0
																	//    0 0  LEDPWM_ON  0 0  	 0 0    0 0    0 0  LEDPWM_ON  0 0

#define RED 								0x0820					//   out 7  out 6   out 5   out 4  out 3   out 2   out 1  out 0
																	//    0 0    0 0  LEDPWM_ON  0 0    0 0  LEDPWM_ON  0 0    0 0

#define LED_MODE							0x01
#define GUI_MODE							0x00

//-----------------------------------------------------------------
//  TCA5405 Single Wire Output Expander Definitions
//-----------------------------------------------------------------
#define DIN		BIT0 												//Location of DIN for bit banging



//-----------------------------------------------------------------
//	TCA7408 I/O Expander I2C Definitions
//-----------------------------------------------------------------
#define TCA7408_ADDRESS						0x44					//TCA7408 address 100 0100 + (R/W bit)
#define TCA7408_OUTPUT_CONFIG				0x03					//I/O Configuration register for TCA7408 1's inputs 0's ouputs
#define OUTPUT_REG							0x05					//Set outputs of TCA7408 (Any values sent to input pins will be ignored)
#define INPUT_DEFAULT_STATE					0x09					//
#define INPUT_STATUS_REG					0x0F					//State of inputs
#define RESISTOR_ENABLE						0x0B
#define INTERRUPT_STATUS_REG				0x13

//-----------------------------------------------------------------
//	TPL0401 Definitions
//-----------------------------------------------------------------
#define TPL0401A_ADDRESS					0x2E					//TPL0401A address is fixed 010 1110 + (R/W bit)
#define TPL0401B_ADDRESS					0x3E					//TPL0401B address is fixed 011 1110 + (R/W bit)
#define TPL0401_REG							0x00

/*******************************************************************
*	Serial Flag definitions										   *
*******************************************************************/
#define VALUE_REQUEST						0x3C
#define RESET_FLAG 							0x7F

#define POTA_TX_FLAG						0x65
#define POTA_RX_FLAG						0x61

#define POTB_TX_FLAG						0x42
#define POTB_RX_FLAG						0x6A


/*******************************************************************
*	 mcu_wake Bit defintions									   *
*******************************************************************/
#define WDT									0x01
#define BUTTON_PRESS						0x02
#define BYTE_IN_WAIT						0x04
#define SEND_VALUES							0x08
#define CLEAR								0x00


